unit MainModule;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, Math, ShellApi;

type
  TForm1 = class(TForm)
    Button_ShellExecute: TButton;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N_FilesIn: TMenuItem;
    N_EmulIn: TMenuItem;
    N_TXT: TMenuItem;
    N2: TMenuItem;
    N_HexDec: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    PaintBox2: TPaintBox;
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Label1: TLabel;
    SaveDialog1: TSaveDialog;
    N1_0: TMenuItem;
    N_AllRangesToRight: TMenuItem;
    N_AllRangesInvertion: TMenuItem;
    OpenDialogEmul: TOpenDialog;
    procedure N_FilesInClick(Sender: TObject);
    procedure N_HexDecClick(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormResize(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure N_TXTClick(Sender: TObject);
    procedure N_AllRangesToRightClick(Sender: TObject);
    procedure N_AllRangesInvertionClick(Sender: TObject);
    procedure N_EmulInClick(Sender: TObject);
    procedure Button_ShellExecuteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function EndGame(): boolean;
  procedure DecreaseFile();

var
  Form1: TForm1;
  F1, F2: File;                       //   ROM-
  arFile: array of byte;              //   -   
  arInf: array of record              // 
                  bgn: integer;       //    
                  opt: integer;       //    
                  lngth: integer;     // 
                  bool: boolean;      //   
                  ar1: array [0..17] of byte;//   1- 
                  ar2: array [0..17] of byte;//   2- 
                  h1: integer;        //     
                  h2, h3: word;       //       
                  end;
  upIndex: integer = -1;              //     arInf
  limit: integer = 32;                //    
  strFileName1: string;               //  
  strFileName2: string;
  strEmul: string;                    //  
  lengthEachFile: integer;            //    
  bhex: boolean = true;               //16-    .  .
  indexSelectedRange: integer;        // ,  
  differenceBetweenFiles: integer;    //  1-    2-

implementation        

uses PreModule;

{$R *.dfm}

////////////////////////////////////////////////////////////////////////////////////////////
//                     
////////////////////////////////////////////////////////////////////////////////////////////

procedure DrawNumber (x,y,number: integer);
//     HEX   DEC
begin
  if bhex
    then Form1.PaintBox1.Canvas.TextOut(x,y,IntToHex(number,1))
    else Form1.PaintBox1.Canvas.TextOut(x,y,IntToStr(number))
end;

procedure RangeInformation();
//     
var
  bg,lng,i: integer;
  str1,str2: string[53];
begin
  bg:=arInf[IndexSelectedRange].bgn;
  lng:=arInf[IndexSelectedRange].lngth;
  Form1.Memo2.Text:=
  Concat('            ===     ',IntToStr(succ(IndexSelectedRange)),
              ' ==='#13#10,
         '  : '#9,IntToHex(bg,1),' h'#9'= ',IntToStr(bg),' d',#13#10,
         '  : '#9,IntToHex(pred(bg+lng),1),' h'#9'= ',
              IntToStr(pred(bg+lng)),' d',#13#10,
         ' , : '#9,IntToHex(lng,1),' h'#9'= ',IntToStr(lng),' d',#13#10,
         '   : '#9,
              FloatToStrF(lng/lengthEachFile*100,ffFixed,4,2),' %');

  if arInf[IndexSelectedRange].bgn>=2        // hex-
    then
        begin
        str1:=Concat(IntToHex(arInf[IndexSelectedRange].ar1[0],2),' ',
                        IntToHex(arInf[IndexSelectedRange].ar1[1],2));
        str2:=Concat(IntToHex(arInf[IndexSelectedRange].ar2[0],2),' ',
                        IntToHex(arInf[IndexSelectedRange].ar2[1],2));
        end
    else
        if arInf[IndexSelectedRange].bgn=1
          then
              begin
              str1:='   '+IntToHex(arInf[IndexSelectedRange].ar1[1],2);
              str2:='   '+IntToHex(arInf[IndexSelectedRange].ar2[1],2);
              end
          else
              begin
              str1:='     ';
              str2:='     ';
              end;

  lng:=min(16,lengthEachFile-arInf[IndexSelectedRange].bgn);
  for i:=2 to succ(lng) do
     begin
     str1:=Concat(str1,' ',IntToHex(arInf[IndexSelectedRange].ar1[i],2));
     str2:=Concat(str2,' ',IntToHex(arInf[IndexSelectedRange].ar2[i],2));
     end;

  str1[6]:='|';
  str2[6]:='|';
  if Length(str1)<53 then begin
                          str1:=str1+' ';
                          str2:=str2+' ';
                          end;
  if arInf[IndexSelectedRange].lngth<16
    then begin
         str1[(2+arInf[IndexSelectedRange].lngth)*3]:='|';
         str2[(2+arInf[IndexSelectedRange].lngth)*3]:='|';
         end;

  Form1.Memo3.Text:=Concat(str1,#13#10,str2);
end;

procedure RefreshAllDiagrams();
//    
begin
  Form1.PaintBox1.Canvas.FillRect(Rect(0,0,Form1.PaintBox1.width,Form1.PaintBox1.Height));
  Form1.PaintBox1Paint(nil);
  Form1.PaintBox2.Canvas.FillRect(Rect(0,0,Form1.PaintBox2.width,Form1.PaintBox2.Height));
  Form1.PaintBox2Paint(nil);
end;

function DefinitionRangeNumber1(y: integer): integer;
var
  i: integer;
begin
  result:=-1;
  for i:=upIndex downto 0 do
     if y>=arInf[i].h1 then
       if y<=arInf[i].h1+35 then break
                            else Exit;
  result:=i;
end;

function DefinitionRangeNumber2(y: integer): integer;
var
  i: integer;
begin
  result:=-1;    
  for i:=upIndex downto 0 do
     if y>=arInf[i].h2 then
       if y<arInf[i].h3 then break
                        else EXIT;
  result:=i;
end;

procedure FilePartChange(i: integer);
//   
var
  lng: integer;
  a: array of byte;
begin
  if arInf[i].bool
    then begin
         Seek(F1,arInf[i].bgn);
         BlockWrite(F1,arFile[arInf[i].opt],arInf[i].lngth);
         end
    else begin
         lng:=arInf[i].lngth;
         SetLength(a,lng);
         Seek(F2,arInf[i].bgn);
         BlockRead(F2,a[0],lng);
         Seek(F1,arInf[i].bgn);
         BlockWrite(F1,a[0],lng);
         end;
  arInf[i].bool:=not arInf[i].bool;
end;

procedure DecreaseFile();
// 
begin
  if differenceBetweenFiles>0
    then begin
         Seek(F2,lengthEachFile-differenceBetweenFiles);
         Truncate(F2);
         end
    else begin
         Seek(F1,lengthEachFile+differenceBetweenFiles);
         Truncate(F1);
         end;
end;

function EndGame():boolean;
// .   TRUE,   ,  FALSE,  
//˨    CANCEL
var
  i: integer;
  str: string;
begin
  if upIndex=-1 then begin
                      result:=true;
                      EXIT;
                      end;

  for i:=0 to upIndex do        //    
     if arInf[i].bool then break;
  if i<succ(upIndex) then
    case MessageDlg(Concat('   (''',ExtractFileName(strFileName1),''')  .     ?'),
                    mtInformation, mbYesNoCancel,0) of
        mrYes:    Form1.N_AllRangesToRightClick(nil);
        mrCancel: begin
                  result:=false;
                  EXIT;
                  end;
        end;

  if differenceBetweenFiles<>0    //       
    then begin
         if differenceBetweenFiles>0
           then str:=strFileName2
           else str:=strFileName1;
         case MessageDlg(Concat('     ''',ExtractFileName(str),'''    .    ?'),
                         mtInformation, mbYesNoCancel,0) of
             mrYes:    DecreaseFile;
             mrCancel: begin
                       result:=false;
                       EXIT;
                       end;
             end;
         end;

  CloseFile(F1);
  CloseFile(F2);
  result:=true;
end;

////////////////////////////////////////////////////////////////////////////////////////////
//              ,    
////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm1.FormResize(Sender: TObject);
//ר         
var
  i: integer;
  R: real;    //      
begin
  if upIndex=-1 then Exit;

  R:=lengthEachFile/(((Panel2.Height-18)div 20 )*20-1);
  for i:=0 to upIndex do        //       
     begin
     arInf[i].h2:=Round(arInf[i].bgn/R) + 9;
     arInf[i].h3:=Round( (arInf[i].bgn+arInf[i].lngth)/R ) + 9;
     if arInf[i].h2=arInf[i].h3 then inc(arInf[i].h3);
     end;

  if PaintBox1.Height<=Panel1.ClientHeight         //  
    then begin
         ScrollBar1.Position:=0;
         ScrollBar1.Visible:=false;
         end
    else begin
         ScrollBar1.PageSize:=1;  //          
         ScrollBar1.Max:=pred(PaintBox1.Height);
         ScrollBar1.LargeChange:=Panel1.ClientHeight;
         ScrollBar1.PageSize:=ScrollBar1.LargeChange;
         ScrollBar1.Visible:=true;
         end;
  ScrollBar1Change(nil);
  RefreshAllDiagrams;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//     
var
  i:integer;
begin
  if upIndex=-1 then EXIT;
  i:=DefinitionRangeNumber1(y);
  if i<0 then EXIT;
  if i<>indexSelectedRange
    then begin
         indexSelectedRange:=i;
         RangeInformation;
         end
    else FilePartChange(i);
  RefreshAllDiagrams;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
//  
var
  h: integer;                // 
  i: integer;                //-
  jb,jl: integer;            // 
  xAdd: integer;             //   
begin
  if upIndex=-1 then Exit;

  with PaintBox1.Canvas do
      begin
      Brush.Color:=clLime;
      Rectangle(15,8,50,PaintBox1.Height-7);  // 

      for i:=0 to upIndex do  // ,   
         begin
         h:=arInf[i].h1;
         Brush.Color:=clRed;
         if arInf[i].bool then xAdd:=15
                          else xAdd:=54;
         Rectangle(xAdd,h,xAdd+35,h+35);     // 
         Font.Color:=clMaroon;
         Font.Name:='Estrangelo Edessa';
         TextOut(xAdd+4,h+4,IntToStr(succ(i)));  // 

         jb:=arInf[i].bgn;
         jl:=arInf[i].lngth;

         Font.Color:=clBlack;
         Brush.Color:=clWhite;
         Font.Name:='Courier';
         DrawNumber(xAdd+39,h-1,jb);             // 
         DrawNumber(xAdd+39,h+23,pred(jb+jl));   //   

         Brush.Color:=$DCDCFF;// 
         DrawNumber(xAdd+55,h+11,jl);      // 
         end;

      Brush.Color:=$DCFFDC;// 
      if arInf[0].bgn<>0 then begin      //   
                              h:=19;
                              DrawNumber(109,h,arInf[0].bgn);
                              end
                         else h:=-15;
      for i:=0 to pred(upIndex) do
         begin
         inc(h,68);
         DrawNumber(109,h,arInf[succ(i)].bgn-arInf[i].bgn-arInf[i].lngth);
         end;
      if arInf[upIndex].bgn<>lengthEachFile-arInf[upIndex].lngth
        then DrawNumber(109,h+68,lengthEachFile-arInf[upIndex].bgn-arInf[upIndex].lngth);

      Pen.Color:=$DF0000;                 //  
      Pen.Width:=5;
      MoveTo(7,arInf[indexSelectedRange].h1);
      LineTo(7,arInf[indexSelectedRange].h1+36);

      Brush.Color:=clWhite;
      Pen.Color:=clBlack;
      Pen.Width:=1;
      end;
end;

procedure TForm1.PaintBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//     
var
  i:integer;
begin
  if upIndex=-1 then EXIT;
  i:=DefinitionRangeNumber2(y);
  if i<0 then EXIT;
  if i<>indexSelectedRange
    then begin
         indexSelectedRange:=i;
         RangeInformation;
         end
    else FilePartChange(i);
  RefreshAllDiagrams;

  if ScrollBar1.Visible=true                     //  ,
    then                                         //      
        if ScrollBar1.Position>arInf[i].h1-8
          then ScrollBar1.Position:=arInf[i].h1-8
          else
              if ScrollBar1.Position+ScrollBar1.LargeChange<arInf[i].h1+42
              then ScrollBar1.Position:=arInf[i].h1+42-ScrollBar1.LargeChange;
end;

procedure TForm1.PaintBox2Paint(Sender: TObject);
//  
var
  h: integer;     //  /  
  i: integer;     // 
  j: integer;     //    / y-    
begin
  if upIndex=-1 then Exit;

  with PaintBox2.Canvas do
      begin
      h:=((Panel2.Height-18)div 20)*20;
      Brush.Color:=clLime;
      Rectangle(15,8,50,9+h);     // 

      Brush.Color:=clRed;      //  
      for i:=0 to upIndex do
         begin
         if arInf[i].bool then j:=16
                          else j:=54;
         FillRect(Rect(j,arInf[i].h2,j+33,arInf[i].h3));
         end;

      h:=h div 20;            // 
      j:=8;
      MoveTo(50,j);
      LineTo(57,j);
      For i:=1 to 10 do
         begin
         inc(j,h);
         MoveTo(47,j);
         LineTo(52,j);
         inc(j,h);
         MoveTo(42,j);
         LineTo(57,j);
         end;
      MoveTo(33,8+h*10);
      LineTo(66,8+h*10);

      Brush.Color:=clWhite;    //     
      Font.Color:=clMaroon;
      for i:=0 to upIndex do
         begin
         if arInf[i].bool then j:=54
                          else j:=92;
         TextOut(j,(arInf[i].h2+arInf[i].h3) div 2 -4, IntToStr(succ(i)));
         end;

      Pen.Color:=$DF0000;           //  
      Pen.Width:=5;
      MoveTo(7,arInf[indexSelectedRange].h2);
      LineTo(7,arInf[indexSelectedRange].h3);
      Pen.Color:=clBlack;
      Pen.Width:=1;
      end;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
//   
begin
  if ScrollBar1.Position>succ(ScrollBar1.Max-ScrollBar1.PageSize)
    then ScrollBar1.Position:=succ(ScrollBar1.Max-ScrollBar1.PageSize);
  PaintBox1.Top:=-ScrollBar1.Position;
end;

////////////////////////////////////////////////////////////////////////////////////////////
//                         
////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm1.N_AllRangesInvertionClick(Sender: TObject);
//    Ψ 
var
  i: integer;
begin
  for i:=0 to upIndex do
     FilePartChange(i);
  RefreshAllDiagrams;
end;

procedure TForm1.N_AllRangesToRightClick(Sender: TObject);
//      
var
  i: integer;
begin
  for i:=0 to upIndex do
     if arInf[i].bool then FilePartChange(i);
  RefreshAllDiagrams;
end;

procedure TForm1.N_EmulInClick(Sender: TObject);
//  
begin
  if strEmul<>''
    then OpenDialogEmul.InitialDir:=ExtractFileDir(strEmul);
  if not OpenDialogEmul.Execute then EXIT;
  strEmul:=OpenDialogEmul.FileName;
  if upIndex<>-1 then Button_ShellExecute.Enabled:=true;
end;

procedure TForm1.N_FilesInClick(Sender: TObject);
//         
//    
var
  i,count: integer;
begin
  if Form2.ShowModal=mrCancel then EXIT;

  i:=(upIndex*2+3)*34;                         //  PaintBox1
  if arInf[0].bgn=0 then dec(i,34);
  if arInf[upIndex].bgn=lengthEachFile-arInf[upIndex].lngth then dec(i,34);
  PaintBox1.Height:=16+i;

  FormResize(nil);

  count:=0;
  for i:=0 to upIndex do
     Inc(count,arInf[i].lngth);

  Memo1.Text:=
  Concat('                      ===   ==='#13#10,
         ' :'#13#10,strFileName1,#13#10,strFileName2,#13#10,
         ' ,   : ',IntToStr(limit),#13#10,
         '    : ',IntToHex(lengthEachFile,1),
              ' h   = ',IntToStr(lengthEachFile),' d',#13#10,
         '   : ',IntToStr(succ(upIndex)),#13#10,
         '    : ',IntToHex(count,1),
              ' h   = ',IntToStr(count),' d',#13#10,
         '    : ',
              FloatToStrF(count/lengthEachFile*100,ffFixed,4,2),' %');
  Memo1.ScrollBars:=ssNone;
  Label1.Visible:=true;
  Memo3.Visible:=true;
  N_TXT.Enabled:=true;
  N_AllRangesToRight.Enabled:=true;
  N_AllRangesInvertion.Enabled:=true;
  N2.Enabled:=true;
  if strEmul<>'' then Button_ShellExecute.Enabled:=true;
  Form2.Panel1.Visible:=false;
  Form2.Panel2.Visible:=true;

  RangeInformation;
end;

procedure TForm1.N_HexDecClick(Sender: TObject);
//      
begin
  bhex:=not bhex;
  if bhex then N2.Caption:='&..: hex'
          else N2.Caption:='&..: dec';
  RefreshAllDiagrams;
end;

procedure TForm1.N_TXTClick(Sender: TObject);
//     
var
  TF: textfile;
  i: integer;
begin
  if not SaveDialog1.Execute then EXIT;
  if FileExists(SaveDialog1.FileName) then
    if MessageDlg('    .   ?',mtInformation,mbOKCancel,0)=mrCancel
      then EXIT;
  AssignFile(TF,SaveDialog1.FileName);
  Rewrite(TF);
  Writeln(TF,Concat('    ''',ExtractFileName(strFileName1),
                    '''  ''',ExtractFileName(strFileName2),
                    '''      = ',IntToStr(limit),
                    ' (dec). (   - hex.)',#13#10#13#10,
                    '              '));
  for i:=0 to upIndex do
     Writeln(TF,Format('%7d%14x%14x%14x',
       [succ(i),arInf[i].bgn,pred(arInf[i].bgn+arInf[i].lngth),arInf[i].lngth]));
  CloseFile(TF);
end;

////////////////////////////////////////////////////////////////////////////////////////////
//                         
////////////////////////////////////////////////////////////////////////////////////////////

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:=EndGame;
end;

procedure TForm1.Button_ShellExecuteClick(Sender: TObject);
begin
  if ShellExecute(Handle, nil, PChar(strEmul), PChar(strFileName1), nil, sw_ShowNormal)<=32
    then ShowMessage('    ');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Constraints.MinHeight := 409+ClientOrigin.Y-Top;
  Canvas.Pen.Color := clGray;
  Panel1.Height := ClientHeight-5;
  Panel2.Height := ClientHeight-5;
end;

procedure TForm1.FormPaint(Sender: TObject);
var x,y,i: Integer;
begin
  x := Memo3.Left+41;
  y := Memo3.Top+29;
  With Canvas do
      For i:=0 to 3 do
         begin
         MoveTo(x,y);
         LineTo(x,y+4);
         Inc(x,84);
         end;
end;

end.

